import { ElementOf } from 'typescript-miscellaneous';
declare function create<Array extends any[]>(elementEqual?: create.ElementEqual<Array>): create.ArrayEqual<Array>;
declare namespace create {
    interface ArrayEqual<Array extends any[]> {
        (a: Array, b: Array): boolean;
    }
    interface ElementEqual<Array extends any[]> {
        (a: ElementOf<Array>, b: ElementOf<Array>, fn: ArrayEqual<Array>): boolean;
    }
    namespace ElementEqual {
        const DEFAULT: (a: any, b: any) => boolean;
    }
}
export = create;
